"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var assert_1 = __importDefault(require("assert"));
var path_1 = require("path");
var t = __importStar(require("@babel/types"));
function transCamel(_str, symbol) {
    var str = _str[0].toLowerCase() + _str.substr(1);
    return str.replace(/([A-Z])/g, function ($1) { return "" + symbol + $1.toLowerCase(); });
}
function winPath(path) {
    return path.replace(/\\/g, '/');
}
function normalizeCustomName(originCustomName) {
    // If set to a string, treat it as a JavaScript source file path.
    if (typeof originCustomName === 'string') {
        // eslint-disable-next-line import/no-dynamic-require
        var customNameExports = require(originCustomName);
        return typeof customNameExports === 'function' ? customNameExports : customNameExports.default;
    }
    return originCustomName;
}
function normalizeOptions(options) {
    return {
        libraryName: options.libraryName,
        libraryDirectory: typeof options.libraryDirectory === 'undefined' ? 'lib' : options.libraryDirectory,
        camel2DashComponentName: typeof options.camel2DashComponentName === 'undefined' ? true : options.camel2DashComponentName,
        camel2UnderlineComponentName: options.camel2UnderlineComponentName,
        style: options.style || false,
        styleLibraryDirectory: options.styleLibraryDirectory,
        customStyleName: normalizeCustomName(options.customStyleName),
        fileName: options.fileName || '',
        customName: normalizeCustomName(options.customName),
        transformToDefaultImport: typeof options.transformToDefaultImport === 'undefined' ? true : options.transformToDefaultImport,
    };
}
function default_1() {
    var configurations = [];
    // Only for test
    // eslint-disable-next-line no-underscore-dangle
    global.__clearBabelAntdPlugin = function () {
        configurations = [];
    };
    return {
        visitor: {
            Program: {
                enter: function (path, _a) {
                    var _b = _a.opts, opts = _b === void 0 ? {} : _b;
                    // Init plugin instances once.
                    if (configurations.length === 0) {
                        if (Array.isArray(opts)) {
                            configurations = opts.map(function (opt) {
                                assert_1.default(opt.libraryName, 'libraryName should be provided');
                                return normalizeOptions(opt);
                            });
                        }
                        else {
                            assert_1.default(opts.libraryName, 'libraryName should be provided');
                            configurations = [normalizeOptions(opts)];
                        }
                    }
                },
            },
            ImportDeclaration: function (path, state) {
                configurations.forEach(function (config) {
                    var node = path.node;
                    var file = path.hub.file || state.file;
                    if (path.get('source').isLiteral({ value: config.libraryName })) {
                        node.specifiers.forEach(function (specifier) {
                            if (!t.isImportSpecifier(specifier)) {
                                throw new Error('babel-plugin-import only support named imports.');
                            }
                            var importedIdentifier = specifier.imported;
                            var localIdentifier = specifier.local;
                            var importedName = importedIdentifier.name;
                            var transformedMethodName = config.camel2UnderlineComponentName // eslint-disable-line
                                ? transCamel(importedName, '_')
                                : config.camel2DashComponentName
                                    ? transCamel(importedName, '-')
                                    : importedName;
                            var customStyleName = normalizeCustomName(config.customStyleName);
                            var customName = normalizeCustomName(config.customName);
                            var importPath = winPath(customName
                                ? customName(transformedMethodName, file)
                                : path_1.join(config.libraryName, config.libraryDirectory, transformedMethodName, config.fileName));
                            var newImport = config.transformToDefaultImport
                                ? t.importDeclaration([t.importDefaultSpecifier(localIdentifier)], t.stringLiteral(importPath))
                                : t.importDeclaration([t.importSpecifier(localIdentifier, importedIdentifier)], t.stringLiteral(importPath));
                            var stylePath = '';
                            path.insertBefore(newImport);
                            if (customStyleName) {
                                stylePath = winPath(customStyleName(transformedMethodName));
                            }
                            else if (config.styleLibraryDirectory) {
                                stylePath = winPath(path_1.join(config.libraryName, config.styleLibraryDirectory, transformedMethodName, config.fileName));
                            }
                            else if (config.style === true) {
                                stylePath = importPath + "/style";
                            }
                            else if (config.style === 'css') {
                                stylePath = importPath + "/style/css";
                            }
                            else if (typeof config.style === 'function') {
                                stylePath = config.style(importPath, file);
                            }
                            if (stylePath) {
                                path.insertBefore(t.importDeclaration([], t.stringLiteral(stylePath)));
                            }
                        });
                        path.remove();
                    }
                });
            },
        },
    };
}
exports.default = default_1;
